#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <math.h>
#include <complex>

#include "fft.h"

using namespace std;

static const complex<double> I = complex<double>(0,1);
static const int N = 4;
static const int M = 8;

#ifndef NMAX//Ȃłȑ傫NMAXĝBȉNMAXSMŒuĂC邯ǁAoOĂ̂ňꉞ`Ă܂
#define NMAX 8192
#define NMAXSQRT 64
#endif

void do_fft1(complex<double> ca[], int flag);//fzflagɉăt[Gϊortt[GϊĂB
void do_fft2(complex<double> ca[][N], int flag);

int main(void){
	complex<double> ca2[N][N], ca1[M];
	int j1, j2, j;
    
	for (j1 = 0; j1 < N; j1++) {
		for (j2 = 0; j2 < N; j2++) {
			ca2[j1][j2] = complex<double>(0,0);
		}
	}
	ca2[0][1] = complex<double>(1,0);//ca2Kɏ܂

	do_fft2(ca2, 1);
	cout << ca2[0][0] << " " << ca2[0][1] << " " << ca2[0][2] << " " << ca2[0][3] <<endl;//vZ킹̂߂ɓKɑIŏo͂Ă܂
	do_fft2(ca2, -1);
	cout << ca2[0][0] << " " << ca2[0][1] << " " << ca2[0][2] << " " << ca2[0][3] <<endl;
	
	for(j=0; j<M; j++){
		ca1[j] = complex<double>(0,0);
	}
	ca1[3] = complex<double>(1,0);
	ca1[4] = complex<double>(1,0);//ca1Kɏ܂

	do_fft1(ca1, 1);
	cout << ca1[0] << " " << ca1[1] << " " << ca1[2] << " " << ca1[3] <<endl;//vZ킹̂߂ɓKɑIŏo͂Ă܂
	do_fft1(ca1, -1);
	cout << ca1[0] << " " << ca1[1] << " " << ca1[2] << " " << ca1[3] <<endl;
}


void do_fft1(complex<double> ca[], int flag){
	int ip[NMAXSQRT + 2], j;
    double a[NMAX + 1], w[NMAX * 5 / 4];//ȑ傫ȔzɂKv͂Ȃ

	if(flag*flag != 1){cout << "flag error" << endl;}

	for(j=0; j<NMAX+1; ++j){
		a[j] = 0;
	}

	for(j=0; j<M; ++j){
		a[j*2] = real(ca[j]);
		a[j*2+1] = imag(ca[j]);
	}

	ip[0] = 0;

	cdft(2*M, flag, a, ip, w);

	if(flag == -1){
		for(j=0; j<2*M; j++){
			a[j] *= 1.0/M;
		}
	}

	for(j=0; j<M; j++){
		ca[j] = a[2*j]+I*a[2*j+1];
	}

	free(ip);
	free(a);
	free(w);
}


void do_fft2(complex<double> ca[ ][N], int flag){
	int *ip, m, i;
	int j1, j2 ;
	double **a, *w;

	if(flag*flag != 1){cout << "flag error" << endl;}

	a = alloc_2d_double(N, 2*N);

    ip = alloc_1d_int(2 + (int) sqrt(N + 0.5));
    m = N/2 + 2*N;
    w = alloc_1d_double(m);
    ip[0] = 0;
    
	for (j1 = 0; j1 < N; j1++) {
		for (j2 = 0; j2 < N; j2++) {
			a[j1][j2*2] = real(ca[j1][j2]) ;//
			a[j1][j2*2+1] = imag(ca[j1][j2]) ;//
		}
	}
	
	cdft2d(N, 2*N, flag, a, ip, w);//a[j1][j2]Fourierϊ  a[k1][k2]

	if(flag == -1){
		for (j1 = 0; j1 < N; j1++) {
			for (j2 = 0; j2 < 2 * N; j2++) {
				a[j1][j2] *= 1.0 / (N * N);
			}
		}
	}

	for (j1 = 0; j1 < N; j1++) {
		for (j2 = 0; j2 < N; j2++) {
			ca[j1][j2] = a[j1][j2*2]+I*a[j1][j2*2+1];
		}
	}

    free_1d_double(w);
    free_1d_int(ip);
    free_2d_double(a);

}
